# Copyright 2016 Jochen Fabricius
# Distribution and modification is encouraged

macro directivity {from to step prefix} {
  set colors [list red purple darkblue yellow darkgreen brown black] 
  for {set angle $from; set i 0} {$angle <= $to} {set angle [expr {$angle+$step}]; incr i} {
    :message "Turn speaker to $angle degrees"
    after 500
    set id [:measure default add]
    :modify #$id Name "${prefix}_${angle}_deg" Color [lindex $colors [expr {$i % [llength $colors]}]]
    lappend curves #$id
  }
  # averaging
  :copy [lindex $curves 0]
  set avg [:paste]
  # rename and hide
  :modify $avg Name "Average_${prefix}_${from}_${to}_deg" Color [lindex $colors [expr {$i % [llength $colors]}]] Show no
  foreach id [lrange $curves 1 end] {
    :expr $avg + $id
  }
  :expr $avg / [llength $curves]
  # make visible
  :modify $avg Show yes
}

